#include "calibration.h"

#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>
#include <stdlib.h>

//Hue, Saturation, Value, Speed
uint8_t H,S,V,Speed;

void hsv_to_rgb(void) {
	uint8_t r,g,b, i, f;
	uint8_t p, q, t;

	if( S == 0 ) 
 	{	r = g = b = V;
	}
	else
	{	i=H/43;
		f=H%43;
		p = (V * (255 - S))/256;
		q = (V * ((10710 - (S * f))/42))/256;
		t = (V * ((10710 - (S * (42 - f)))/42))/256;

		switch( i )
		{	case 0:
				r = V; g = t; b = p; break;
			case 1:
				r = q; g = V; b = p; break;
			case 2:
				r = p; g = V; b = t; break;
			case 3:
				r = p; g = q; b = V; break;			
			case 4:
				r = t; g = p; b = V; break;				
			case 5:
			default:
	 			r = V; g = p; b = q; break;
		}
	}

	r=get_calibration(red_calibration,r);
	g=get_calibration(green_calibration,g);
	b=get_calibration(blue_calibration,b);
	cli();                                              // Kein Interrupt beim Übernehmen der neuen Werte!
	red_pwm=r, green_pwm=g, blue_pwm=b;      
	sei();
}
